%ext ck1
%patchfile 0x130F8 Xmas.tli
%patch $1B8B $00 #If the Garg is shorter or Keen is taller: 
%patch $1B89 $EA
%patch $1782 $04 $00 # make touching a butler bot the last thing you ever do 
%patch $2058 $05 #Ice cannon shoot rate

#Change the Done tile markers
# Single tile "Done" marker 
%patch $7D88  $50 $00 

# Four-tile "Done" marker 
%patch $7DFC  $50 $00 
%patch $7E14  $50 $00 
%patch $7E2A  $50 $00 
%patch $7E43  $50 $00 

# Change the teleporter so it works within the level (updated 24/09/03) 
%patch $8919                           $89 $F0 $F7 $2E $08 $6C $01 
   $F8 $D1 $E0 $C4 $1E $4C $6C $01 $C3 $26 $8B $07 $50 $88 $E0 $98 
   $99 $01 $F0 $83 $D2 $00 $B1 $0C $E8 $16 $58 $89 $16 $E4 $6E $A3 
   $E2 $6E $05 $00 $B0 $83 $D2 $FF $A3 $D4 $6E $89 $16 $D6 $6E $58 
   $98 $99 $01 $F8 $83 $D2 $00 $B1 $0C $E8 $F5 $57 $89 $16 $E0 $6E 
   $A3 $DE $6E $05 $00 $70 $83 $D2 $FF $A3 $D0 $6E $89 $16 $D2 $6E 
   $C3 
%patch $4572  $E8 $A4 $43 $EB $13 $90 


%patch $98B2 $90 #Don't show Parts sprite

%patch $98D5 $90 #Don't show all items

%patch $412E $00 #Exit tiles don't change.

%patch $41CD $90 #Keen dissappears as soon as he touches the exit; pause before exiting level

%patch $48E9 $04 $00 #robot's shots kill Keen but not other enemies

%patch $176D $6E $1D # Robot turns to dead Vort when shot  

%patch 0x8020 $83 $BF $A6 $AA $01 $75 $1E $E8 $62 $01 $EB $29 #Keen only has to complete 1 level to win [first 00 is level] [The fifth $xy]

%patch $9059 $01 #keycard 4 

# leaves 227 spare bytes at CS:10D1 
# leaves 164 spare bytes at DS:1E02 ($14E52) 
# Patch in the long-integer drawing function 
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 
%patch $13084  "STATUS.CK1" $00 
# Patch in the code to draw the status text (coordinates are measure in characters--8 pixel blocks) 
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00   # Show status window (0E6A) 
               $CD $21 $89 $C3 $BF $27 $00 $C6 $06 $9A $82 $00 $B9 $0A $00 $BA 
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21 
                                               $8B $46 $FE $05 $01 $00 $50 $89   # Show score (0E98) 
               $F0 $05 $0A $00 $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03 
               $83 $C4 $08 
                           $8B $46 $FE $05 $01 $00 $50 $89 $F0 $05 $1A $00 $50   # Show extra Keen score (0EB3) 
               $A1 $C4 $6E $8B $16 $C2 $6E $81 $C2 $20 $4E $15 $00 $00 $50 $52 
               $E8 $E1 $02 $83 $C4 $08 
                                       $31 $FF $3B $3E $C6 $AA $7D $29 $83 $FF   # Show Keens (0ED6) 
               $06 $7D $24 $B8 $7B $00 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 
               $E0 $90 $90 $50 $89 $F8 $D1 $E0 $05 $01 $00 $01 $F0 $50 $E8 $2C 
               $AC $83 $C4 $06 $47 $EB $D1 
%patch $0F07                               $B8 $41 $01 $83 $3E $94 $AA $00 $74   # Draw the joystick 
               $03 $B8 $3D $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $10 $00 $50 $E8 $0D $AA $83 $C4 $06 
                                                                           $B8   # Draw the battery 
               $42 $01 $83 $3E $9C $AA $00 $74 $03 $B8 $3E $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $13 $00 
               $50 $E8 $E5 $A9 $83 $C4 $06 
                                           $B8 $43 $01 $83 $3E $96 $AA $00 $74   # Draw the vacuum 
               $03 $B8 $3F $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $16 $00 $50 $E8 $BD $A9 $83 $C4 $06 
                                                                           $B8   # Draw the whiskey 
               $44 $01 $83 $3E $98 $AA $00 $74 $03 $B8 $40 $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $19 $00 
               $50 $E8 $95 $A9 $83 $C4 $06 
%patch $0FA7                               $B8 $2E $02 $83 $3E $9E $AA $00 $74   # Keycard A 
               $03 $B8 $A8 $01 $50 $8B $46 $FE $05 $07 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $6D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard B 
               $2E $02 $83 $3E $A0 $AA $00 $74 $03 $B8 $A9 $01 $50 $8B $46 $FE 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $45 $A9 $83 $C4 $06 
                                           $B8 $2E $02 $83 $3E $A2 $AA $00 $74   # Keycard C 
               $03 $B8 $AA $01 $50 $8B $46 $FE $05 $09 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $1D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard D 
               $2E $02 $83 $3E $A4 $AA $00 $74 $03 $B8 $AB $01 $50 $8B $46 $FE 
               $05 $09 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $F5 $A8 $83 $C4 $06 
%patch $1047                               $B8 $2E $02 $83 $3E $9A $AA $00 $74   # Pogo stick 
               $03 $B8 $9F $01 $50 $8B $46 $FE $05 $08 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $2E $02 $50 $E8 $CD $A8 $83 $C4 $06 
                                                                           $8B   # Draw ammo 
               $46 $FE $05 $0B $02 $50 $89 $F0 $05 $06 $02 $50 $31 $C0 $50 $FF 
               $36 $C8 $AA $E8 $2E $01 $83 $C4 $08 
                                                   $B8 $9E $01 $50 $8B $46 $FE   # Draw raygun (replace first two bytes 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $03 $00   # with $EB $1C if you don't want to 
               $50 $E8 $95 $A8 $83 $C4 $06                                       # draw the raygun on the status screen) 

                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD   # Wait for a key, then return 
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3 


%patch $2F31  $E8 $9D $E1 $90 $90 # Make the door act like a wall when moving right
%patch $2FE6  $E8 $0B $E1 $90 $90 # Make the door act like a wall when moving left
# Here's where the real work is done
%patch $10D1  $81 $3E $54 $82 $C4 $45 $75 $15
              $8B $87 $6E $05 $48 $48 $3D $04
              $00 $73 $0A $89 $C3 $D1 $E3 $83
              $BF $9E $AA $01 $C3 $83 $BF $86
              $18 $00 $C3 $81 $3E $54 $82 $C4
              $45 $75 $15 $8B $87 $6E $05 $48
              $48 $3D $04 $00 $73 $0A $89 $C3
              $D1 $E3 $83 $BF $9E $AA $01 $C3
              $83 $BF $FA $0E $00 $C3
%patch $43A4  $E9 $D1 $01 #Stop the door bouncing 
#Keen 1 background tiles behave like Keen 3
%patch $4409      $26 $8B $07 $B6 $0D $F6 $FE 
%patch $4410  $F6 $EE $26 $89 $07 $E9 $60 $01 

%patch $4482  $E9 $74 $FF 
%patch $44BA  $E9 $3C $FF 
%patch $4513  $E9 $E3 $FE 

%patch $28EC                  $26 $8B $07 $B6 
%patch $28F0  $0D $F6 $FE $F6 $EE $26 $89 $07 
%patch $28F8  $03 $1E $08 $6C $03 $1E $08 $6C 
%patch $2900  $26 $89 $07 $90 $90 $90 $90 $90 

%patch $1BFA $68 $1A #shot garg becomes dead yorp
#Menu
%patch 0x015EF6 "Continue Game"
%patch 0x015F12 "Stealthy   "
%patch 0x015F22 "the List   "
%patch 0x015F32 "Keen Modding "
#Status Screen
%patch 0x014F74 "EXTRA LIFE AT"
%patch 0x014F8B "Gorti"
%patch 0x014F97 "Cheat Code"
%patch 0x014FAF "C.C.  "
%patch 0x014FB8 "JUMP"
%patch 0x014FC0 "KEYS    "
%patch 0x014FDC "CHARGE"
%patch 0x015FCE "Lives Left"
#About ID...
%patch 0x015F80 "Stealthy71088 is an individual who"
%patch 0x015FA8 "feels that Christmas is keen. He's"
%patch 0x015FD0 "been modding keen for 5+ years"
%patch 0x015FF8 "now. He's likes making levels."
%patch 0x016020 "This is dedicated to his"
%patch 0x016048 "family and to his friends"
%patch 0x016070 "Colton, Greg, Jen"
%patch 0x016098 "Danielle and Nicole."
%patch 0x0160C0 "Stealthy hopes you  "
%patch 0x0160E8 "enjoy his game.     "
%patch 0x016110 "Bah, Humbug!       "
#Ordering Info
%patch 0x01632C "Keen Modding is the site"
%patch 0x016346 "I got all the patches and"
%patch 0x016364 "utilities needed to"
%patch 0x01637B "make this game.      "
%patch 0x016392 "Making games is easy,    "
%patch 0x0163AD "but it is time consuming."
%patch 0x0163C8 "Utilities I used included"
%patch 0x0163E4 "KeenWright                           "
%patch 0x01640D "Modkeen                            "
%patch 0x016434 "CK1patch                           "
%patch 0x01645B "Tileinfo                         "
%patch 0x016480 "Fin2bmp             "
%patch 0x0164B5 "Shadowkeen 1-3 "
%patch 0x0164DD "Xkykeen 1-3    "
%patch 0x016505 "Norp Quartology"
%patch 0x01652D "Clones of Evil   "
%patch 0x01646C "Good Mods to dl "
%patch 0x0164EE "Storyland      "
%patch 0x016516 "A New Dope     "
%patch 0x016542 "Visit our website at                   "
%patch 0x016573 "www.andydurdin.com/keen/modding   "
#High Score Entries
%patch 0x015A03 "Santa"
%patch 0x015A12 "Jack   "
%patch 0x015A21 "Giften"
#Loading...
%patch 0x014F1D "Loading Gorti Vrinch's Xmas... (version 2.0)  "
#Your ship is missing...
%patch 0x01659B "Secret Message      "
%patch 0x0165B0 "needs words "
%patch 0x0165C6 "GO FIND THEM"
#God mode
%patch 0x019EF6 "Hot Cocoa is fun"
%patch 0x019F07 "You look cold.   "
#God Cheat Code
%patch 0x0120D 0x504F
%patch 0x01214 0x5044
%patch 0x0121B 0x5040
#CTSpace Cheat Code (SWSpace) (A reference to Star Wars)
%patch 0x011F5 0x504B
%patch 0x011FC 0x503D
%patch 0x01203 0x5065
#CTSpace
%patch 0x014DEE "You uncovered the    "
%patch 0x014E05 "Cheat code. Congrats.     "
%patch 0x014E21 "Type in HOT           "
%patch 0x014E39 "to turn on invincibility"
#Finale
%patch 0x015C24 "Gorti Vrinch escapes Keen's house  "
%patch 0x015C49 "and runs to his sled with all the"
%patch 0x015C6C "presents. His sled is too heavy to "
%patch 0x015C91 "take off, so he goes to Mt. Icy"

# First dialogue box at home
%patch 0x015CBD "Vrinch gets to the    "
%patch 0x015CD5 "summit and glares "
%patch 0x015CE9 "down at the house"

%patch 0x015CFB "Gorti: Keen's wakin"
%patch 0x015D10 "up. Time to see him"
%patch 0x015D25 "cry.      "

%patch 0x015D30 "Billy: No presents.   "
#Text jump
%patch 0x015D47 "No candy. Coal        "
%patch 0x015D5E "galore for me and"
%patch 0x015D73 "not Mort?!?"

%patch 0x015D80 "Mom: Shouldn't  "
%patch 0x015D92 "you sing "

%patch 0x015D9C "Happy B-day to        "
%patch 0x015DB4 "Jesus? After all... "
%patch 0x015DCA "Billy: Happy Birthday.."

%patch 0x015DE2 "Gorti: Wha? He's not"

%patch 0x015DF6 "crying."

%patch 0x015E07 "Gorti: Is there more"
%patch 0x015E1E "to Xmas than gifts?"
%patch 0x015E37 "Is greed not the"
%patch 0x015E4C "anwser? Should I give"
%patch 0x015E63 "the gifts back?"

%patch $15E72 "     Nah!       "

%level.hint 2
Stealthy:I guess
they weren't kidding
about forcing me to 
sleep outside if I
didn't stop playing 
with the raygun.

%level.hint 6
A Salvation 
Army Santa says: 
Vrinch, you 
must be seven 
reindeer short 
of a sled team.

%level.hint 9
The crazy boy 
says: Vrinch, 
I think your 
morals are
starting to
slip.

%level.hint 10
That guy from
B52 thinks: If
love was really
so great, it
would get a
castle, not a
little shack!

%level.hint 11
Mario says: Could
you spare 70
stars please?

%end

#I was going to have other messages in the original game as well, but it didn't work. These are what they would have been.

#level.hint 6
#Your brother
#groans: Why does
#Billy always look
#like he believes
#the Universe is 
#about to end?
#I mean really...

#level.hint 9
#Your Sister 
#moans: I wish I 
#could dance 
#like those sugar
#plums. That would
#be very cool.

#%level.hint 10
#Molly moans:
#I have to find
#some way to keep
#Billy from drugging
#me with sedatives,
#or I'll sleep when
#his parents come...

#%level.hint 11
#Mortimer: Keen will
#never suspect that
#I'm sleeping here.

#%level.hint 12
#Marty Mold the
#houseelf says:
#I wonder what
#happens if you
#beat the game
#without dying?

#%level.hint 15
#Your parents argue
#Mother: You know, 
#he gets his IQ
#from me dear.
#Father: No no, 
#it must be me.